﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

// 
// This source code was auto-generated by Microsoft.VSDesigner, Version 4.0.30319.42000.
// 
#pragma warning disable 1591

namespace Tooska.Payment.com.zarinpal.www {
    using System;
    using System.Web.Services;
    using System.Diagnostics;
    using System.Web.Services.Protocols;
    using System.Xml.Serialization;
    using System.ComponentModel;
    
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Web.Services.WebServiceBindingAttribute(Name="PaymentGatewayImplementationServiceBinding", Namespace="http://zarinpal.com/")]
    public partial class PaymentGatewayImplementationService : System.Web.Services.Protocols.SoapHttpClientProtocol {
        
        private System.Threading.SendOrPostCallback PaymentRequestOperationCompleted;
        
        private System.Threading.SendOrPostCallback PaymentRequestWithExtraOperationCompleted;
        
        private System.Threading.SendOrPostCallback PaymentVerificationOperationCompleted;
        
        private System.Threading.SendOrPostCallback PaymentVerificationWithExtraOperationCompleted;
        
        private System.Threading.SendOrPostCallback GetUnverifiedTransactionsOperationCompleted;
        
        private System.Threading.SendOrPostCallback RefreshAuthorityOperationCompleted;
        
        private bool useDefaultCredentialsSetExplicitly;
        
        /// <remarks/>
        public PaymentGatewayImplementationService() {
            this.Url = Tooska.Payment.GatewayAddresses.ZARINPAL;
            if ((this.IsLocalFileSystemWebService(this.Url) == true)) {
                this.UseDefaultCredentials = true;
                this.useDefaultCredentialsSetExplicitly = false;
            }
            else {
                this.useDefaultCredentialsSetExplicitly = true;
            }
        }
        
        public new string Url {
            get {
                return base.Url;
            }
            set {
                if ((((this.IsLocalFileSystemWebService(base.Url) == true) 
                            && (this.useDefaultCredentialsSetExplicitly == false)) 
                            && (this.IsLocalFileSystemWebService(value) == false))) {
                    base.UseDefaultCredentials = false;
                }
                base.Url = value;
            }
        }
        
        public new bool UseDefaultCredentials {
            get {
                return base.UseDefaultCredentials;
            }
            set {
                base.UseDefaultCredentials = value;
                this.useDefaultCredentialsSetExplicitly = true;
            }
        }
        
        /// <remarks/>
        public event PaymentRequestCompletedEventHandler PaymentRequestCompleted;
        
        /// <remarks/>
        public event PaymentRequestWithExtraCompletedEventHandler PaymentRequestWithExtraCompleted;
        
        /// <remarks/>
        public event PaymentVerificationCompletedEventHandler PaymentVerificationCompleted;
        
        /// <remarks/>
        public event PaymentVerificationWithExtraCompletedEventHandler PaymentVerificationWithExtraCompleted;
        
        /// <remarks/>
        public event GetUnverifiedTransactionsCompletedEventHandler GetUnverifiedTransactionsCompleted;
        
        /// <remarks/>
        public event RefreshAuthorityCompletedEventHandler RefreshAuthorityCompleted;
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("#PaymentRequest", RequestNamespace="http://zarinpal.com/", ResponseNamespace="http://zarinpal.com/", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlElementAttribute("Status")]
        public int PaymentRequest(string MerchantID, int Amount, string Description, [System.Xml.Serialization.XmlElementAttribute(IsNullable=true)] string Email, [System.Xml.Serialization.XmlElementAttribute(IsNullable=true)] string Mobile, string CallbackURL, out string Authority) {
            object[] results = this.Invoke("PaymentRequest", new object[] {
                        MerchantID,
                        Amount,
                        Description,
                        Email,
                        Mobile,
                        CallbackURL});
            Authority = ((string)(results[1]));
            return ((int)(results[0]));
        }
        
        /// <remarks/>
        public void PaymentRequestAsync(string MerchantID, int Amount, string Description, string Email, string Mobile, string CallbackURL) {
            this.PaymentRequestAsync(MerchantID, Amount, Description, Email, Mobile, CallbackURL, null);
        }
        
        /// <remarks/>
        public void PaymentRequestAsync(string MerchantID, int Amount, string Description, string Email, string Mobile, string CallbackURL, object userState) {
            if ((this.PaymentRequestOperationCompleted == null)) {
                this.PaymentRequestOperationCompleted = new System.Threading.SendOrPostCallback(this.OnPaymentRequestOperationCompleted);
            }
            this.InvokeAsync("PaymentRequest", new object[] {
                        MerchantID,
                        Amount,
                        Description,
                        Email,
                        Mobile,
                        CallbackURL}, this.PaymentRequestOperationCompleted, userState);
        }
        
        private void OnPaymentRequestOperationCompleted(object arg) {
            if ((this.PaymentRequestCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.PaymentRequestCompleted(this, new PaymentRequestCompletedEventArgs(invokeArgs.Results, invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("#PaymentRequestWithExtra", RequestNamespace="http://zarinpal.com/", ResponseNamespace="http://zarinpal.com/", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlElementAttribute("Status")]
        public int PaymentRequestWithExtra(string MerchantID, int Amount, string Description, string AdditionalData, [System.Xml.Serialization.XmlElementAttribute(IsNullable=true)] string Email, [System.Xml.Serialization.XmlElementAttribute(IsNullable=true)] string Mobile, string CallbackURL, out string Authority) {
            object[] results = this.Invoke("PaymentRequestWithExtra", new object[] {
                        MerchantID,
                        Amount,
                        Description,
                        AdditionalData,
                        Email,
                        Mobile,
                        CallbackURL});
            Authority = ((string)(results[1]));
            return ((int)(results[0]));
        }
        
        /// <remarks/>
        public void PaymentRequestWithExtraAsync(string MerchantID, int Amount, string Description, string AdditionalData, string Email, string Mobile, string CallbackURL) {
            this.PaymentRequestWithExtraAsync(MerchantID, Amount, Description, AdditionalData, Email, Mobile, CallbackURL, null);
        }
        
        /// <remarks/>
        public void PaymentRequestWithExtraAsync(string MerchantID, int Amount, string Description, string AdditionalData, string Email, string Mobile, string CallbackURL, object userState) {
            if ((this.PaymentRequestWithExtraOperationCompleted == null)) {
                this.PaymentRequestWithExtraOperationCompleted = new System.Threading.SendOrPostCallback(this.OnPaymentRequestWithExtraOperationCompleted);
            }
            this.InvokeAsync("PaymentRequestWithExtra", new object[] {
                        MerchantID,
                        Amount,
                        Description,
                        AdditionalData,
                        Email,
                        Mobile,
                        CallbackURL}, this.PaymentRequestWithExtraOperationCompleted, userState);
        }
        
        private void OnPaymentRequestWithExtraOperationCompleted(object arg) {
            if ((this.PaymentRequestWithExtraCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.PaymentRequestWithExtraCompleted(this, new PaymentRequestWithExtraCompletedEventArgs(invokeArgs.Results, invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("#PaymentVerification", RequestNamespace="http://zarinpal.com/", ResponseNamespace="http://zarinpal.com/", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlElementAttribute("Status")]
        public int PaymentVerification(string MerchantID, string Authority, int Amount, out long RefID) {
            object[] results = this.Invoke("PaymentVerification", new object[] {
                        MerchantID,
                        Authority,
                        Amount});
            RefID = ((long)(results[1]));
            return ((int)(results[0]));
        }
        
        /// <remarks/>
        public void PaymentVerificationAsync(string MerchantID, string Authority, int Amount) {
            this.PaymentVerificationAsync(MerchantID, Authority, Amount, null);
        }
        
        /// <remarks/>
        public void PaymentVerificationAsync(string MerchantID, string Authority, int Amount, object userState) {
            if ((this.PaymentVerificationOperationCompleted == null)) {
                this.PaymentVerificationOperationCompleted = new System.Threading.SendOrPostCallback(this.OnPaymentVerificationOperationCompleted);
            }
            this.InvokeAsync("PaymentVerification", new object[] {
                        MerchantID,
                        Authority,
                        Amount}, this.PaymentVerificationOperationCompleted, userState);
        }
        
        private void OnPaymentVerificationOperationCompleted(object arg) {
            if ((this.PaymentVerificationCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.PaymentVerificationCompleted(this, new PaymentVerificationCompletedEventArgs(invokeArgs.Results, invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("#PaymentVerificationWithExtra", RequestNamespace="http://zarinpal.com/", ResponseNamespace="http://zarinpal.com/", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlElementAttribute("Status")]
        public int PaymentVerificationWithExtra(string MerchantID, string Authority, int Amount, out long RefID, out string ExtraDetail) {
            object[] results = this.Invoke("PaymentVerificationWithExtra", new object[] {
                        MerchantID,
                        Authority,
                        Amount});
            RefID = ((long)(results[1]));
            ExtraDetail = ((string)(results[2]));
            return ((int)(results[0]));
        }
        
        /// <remarks/>
        public void PaymentVerificationWithExtraAsync(string MerchantID, string Authority, int Amount) {
            this.PaymentVerificationWithExtraAsync(MerchantID, Authority, Amount, null);
        }
        
        /// <remarks/>
        public void PaymentVerificationWithExtraAsync(string MerchantID, string Authority, int Amount, object userState) {
            if ((this.PaymentVerificationWithExtraOperationCompleted == null)) {
                this.PaymentVerificationWithExtraOperationCompleted = new System.Threading.SendOrPostCallback(this.OnPaymentVerificationWithExtraOperationCompleted);
            }
            this.InvokeAsync("PaymentVerificationWithExtra", new object[] {
                        MerchantID,
                        Authority,
                        Amount}, this.PaymentVerificationWithExtraOperationCompleted, userState);
        }
        
        private void OnPaymentVerificationWithExtraOperationCompleted(object arg) {
            if ((this.PaymentVerificationWithExtraCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.PaymentVerificationWithExtraCompleted(this, new PaymentVerificationWithExtraCompletedEventArgs(invokeArgs.Results, invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("#GetUnverifiedTransactions", RequestNamespace="http://zarinpal.com/", ResponseNamespace="http://zarinpal.com/", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlElementAttribute("Status")]
        public int GetUnverifiedTransactions(string MerchantID, out string Authorities) {
            object[] results = this.Invoke("GetUnverifiedTransactions", new object[] {
                        MerchantID});
            Authorities = ((string)(results[1]));
            return ((int)(results[0]));
        }
        
        /// <remarks/>
        public void GetUnverifiedTransactionsAsync(string MerchantID) {
            this.GetUnverifiedTransactionsAsync(MerchantID, null);
        }
        
        /// <remarks/>
        public void GetUnverifiedTransactionsAsync(string MerchantID, object userState) {
            if ((this.GetUnverifiedTransactionsOperationCompleted == null)) {
                this.GetUnverifiedTransactionsOperationCompleted = new System.Threading.SendOrPostCallback(this.OnGetUnverifiedTransactionsOperationCompleted);
            }
            this.InvokeAsync("GetUnverifiedTransactions", new object[] {
                        MerchantID}, this.GetUnverifiedTransactionsOperationCompleted, userState);
        }
        
        private void OnGetUnverifiedTransactionsOperationCompleted(object arg) {
            if ((this.GetUnverifiedTransactionsCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.GetUnverifiedTransactionsCompleted(this, new GetUnverifiedTransactionsCompletedEventArgs(invokeArgs.Results, invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("#RefreshAuthority", RequestNamespace="http://zarinpal.com/", ResponseNamespace="http://zarinpal.com/", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlElementAttribute("Status")]
        public int RefreshAuthority(string MerchantID, string Authority, int ExpireIn) {
            object[] results = this.Invoke("RefreshAuthority", new object[] {
                        MerchantID,
                        Authority,
                        ExpireIn});
            return ((int)(results[0]));
        }
        
        /// <remarks/>
        public void RefreshAuthorityAsync(string MerchantID, string Authority, int ExpireIn) {
            this.RefreshAuthorityAsync(MerchantID, Authority, ExpireIn, null);
        }
        
        /// <remarks/>
        public void RefreshAuthorityAsync(string MerchantID, string Authority, int ExpireIn, object userState) {
            if ((this.RefreshAuthorityOperationCompleted == null)) {
                this.RefreshAuthorityOperationCompleted = new System.Threading.SendOrPostCallback(this.OnRefreshAuthorityOperationCompleted);
            }
            this.InvokeAsync("RefreshAuthority", new object[] {
                        MerchantID,
                        Authority,
                        ExpireIn}, this.RefreshAuthorityOperationCompleted, userState);
        }
        
        private void OnRefreshAuthorityOperationCompleted(object arg) {
            if ((this.RefreshAuthorityCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.RefreshAuthorityCompleted(this, new RefreshAuthorityCompletedEventArgs(invokeArgs.Results, invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        public new void CancelAsync(object userState) {
            base.CancelAsync(userState);
        }
        
        private bool IsLocalFileSystemWebService(string url) {
            if (((url == null) 
                        || (url == string.Empty))) {
                return false;
            }
            System.Uri wsUri = new System.Uri(url);
            if (((wsUri.Port >= 1024) 
                        && (string.Compare(wsUri.Host, "localHost", System.StringComparison.OrdinalIgnoreCase) == 0))) {
                return true;
            }
            return false;
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    public delegate void PaymentRequestCompletedEventHandler(object sender, PaymentRequestCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    public partial class PaymentRequestCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
        
        private object[] results;
        
        internal PaymentRequestCompletedEventArgs(object[] results, System.Exception exception, bool cancelled, object userState) : 
                base(exception, cancelled, userState) {
            this.results = results;
        }
        
        /// <remarks/>
        public int Result {
            get {
                this.RaiseExceptionIfNecessary();
                return ((int)(this.results[0]));
            }
        }
        
        /// <remarks/>
        public string Authority {
            get {
                this.RaiseExceptionIfNecessary();
                return ((string)(this.results[1]));
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    public delegate void PaymentRequestWithExtraCompletedEventHandler(object sender, PaymentRequestWithExtraCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    public partial class PaymentRequestWithExtraCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
        
        private object[] results;
        
        internal PaymentRequestWithExtraCompletedEventArgs(object[] results, System.Exception exception, bool cancelled, object userState) : 
                base(exception, cancelled, userState) {
            this.results = results;
        }
        
        /// <remarks/>
        public int Result {
            get {
                this.RaiseExceptionIfNecessary();
                return ((int)(this.results[0]));
            }
        }
        
        /// <remarks/>
        public string Authority {
            get {
                this.RaiseExceptionIfNecessary();
                return ((string)(this.results[1]));
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    public delegate void PaymentVerificationCompletedEventHandler(object sender, PaymentVerificationCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    public partial class PaymentVerificationCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
        
        private object[] results;
        
        internal PaymentVerificationCompletedEventArgs(object[] results, System.Exception exception, bool cancelled, object userState) : 
                base(exception, cancelled, userState) {
            this.results = results;
        }
        
        /// <remarks/>
        public int Result {
            get {
                this.RaiseExceptionIfNecessary();
                return ((int)(this.results[0]));
            }
        }
        
        /// <remarks/>
        public long RefID {
            get {
                this.RaiseExceptionIfNecessary();
                return ((long)(this.results[1]));
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    public delegate void PaymentVerificationWithExtraCompletedEventHandler(object sender, PaymentVerificationWithExtraCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    public partial class PaymentVerificationWithExtraCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
        
        private object[] results;
        
        internal PaymentVerificationWithExtraCompletedEventArgs(object[] results, System.Exception exception, bool cancelled, object userState) : 
                base(exception, cancelled, userState) {
            this.results = results;
        }
        
        /// <remarks/>
        public int Result {
            get {
                this.RaiseExceptionIfNecessary();
                return ((int)(this.results[0]));
            }
        }
        
        /// <remarks/>
        public long RefID {
            get {
                this.RaiseExceptionIfNecessary();
                return ((long)(this.results[1]));
            }
        }
        
        /// <remarks/>
        public string ExtraDetail {
            get {
                this.RaiseExceptionIfNecessary();
                return ((string)(this.results[2]));
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    public delegate void GetUnverifiedTransactionsCompletedEventHandler(object sender, GetUnverifiedTransactionsCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    public partial class GetUnverifiedTransactionsCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
        
        private object[] results;
        
        internal GetUnverifiedTransactionsCompletedEventArgs(object[] results, System.Exception exception, bool cancelled, object userState) : 
                base(exception, cancelled, userState) {
            this.results = results;
        }
        
        /// <remarks/>
        public int Result {
            get {
                this.RaiseExceptionIfNecessary();
                return ((int)(this.results[0]));
            }
        }
        
        /// <remarks/>
        public string Authorities {
            get {
                this.RaiseExceptionIfNecessary();
                return ((string)(this.results[1]));
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    public delegate void RefreshAuthorityCompletedEventHandler(object sender, RefreshAuthorityCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.6.1586.0")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    public partial class RefreshAuthorityCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
        
        private object[] results;
        
        internal RefreshAuthorityCompletedEventArgs(object[] results, System.Exception exception, bool cancelled, object userState) : 
                base(exception, cancelled, userState) {
            this.results = results;
        }
        
        /// <remarks/>
        public int Result {
            get {
                this.RaiseExceptionIfNecessary();
                return ((int)(this.results[0]));
            }
        }
    }
}

#pragma warning restore 1591